using System.Diagnostics.CodeAnalysis;
using System.Runtime.InteropServices;

namespace WinFormsApp1
{
    public unsafe partial class Form1 : Form //, IMessageFilter
    {
        //[DllImport("user32.dll", CharSet = CharSet.Auto)]
        //static extern bool IsDialogMessageW(IntPtr hWnd, ref MSG msg);

        [AllowNull]
        FindTextDialog _dlg;
        public Form1()
        {
            InitializeComponent();
            // Application.AddMessageFilter(this);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _dlg = new FindTextDialog(this.Handle);
            _dlg.CreateDialog();
            this.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _dlg.CreateDialog();
            this.Enabled = false;
        }

        unsafe void OnFindReplace(IntPtr hwnd, FINDREPLACEW* pfr)
        {
            if (_dlg.HasCloseFlag())
            {
                _dlg.Close();
                this.Enabled = true;
                return;
            }

            if (_dlg.HasFindNextFlag())
            {
                MessageBox.Show(_dlg.Text);
            }
        }

        protected override void WndProc(ref Message m)
        {
            if (_dlg != null && _dlg.IsFindMessage(m.Msg) == true)
            {
                OnFindReplace(m.HWnd, (FINDREPLACEW*)m.LParam.ToPointer());
                return;
            }
            
            base.WndProc(ref m);
        }

        protected override void OnFormClosed(FormClosedEventArgs e)
        {
            // Application.RemoveMessageFilter(this);
            _dlg.Dispose();
            _dlg = null;

            base.OnFormClosed(e);
        }

        //public bool PreFilterMessage(ref Message m)
        //{
        //    MSG msg = MSG.From(m);
        //    if (_dlg != null && IsDialogMessageW(_dlg.Handle, ref msg) == true) // IsDialogMessageW 호출이 필요 없음
        //    {
        //        return true;
        //    }

        //    return false;
        //}
    }
}

